package net.roseindia;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class JavaXmlParserClazUsingDOM {
	public static void main(String[] args) {

		// getting Document builder factory instance
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
		Document document;

		try {

			// getting DocumentBuilder instance using documentBuilderFactory
			DocumentBuilder documentBuilder = dbFactory.newDocumentBuilder();

			// Parsing XML file using DocumentBuilder
			document = documentBuilder.parse("C:\\Students.xml");

			// Getting Element of XML file
			Element docElement = document.getDocumentElement();

			// Getting Element By TagName
			NodeList nodeList = docElement.getElementsByTagName("Student");
			JavaXmlParserClazUsingDOM myClass = new JavaXmlParserClazUsingDOM();

			if (nodeList != null && nodeList.getLength() > 0) {
				System.out.println("Name\tID\tAge\tType\n");				
				for (int i = 0; i < nodeList.getLength(); i++) {					
					Element element = (Element) nodeList.item(i);
					System.out.print(myClass.getData(element, "Name") + "\t");
					System.out.print(myClass.getData(element, "RollNo") + "\t");
					System.out.print(myClass.getData(element, "Age") + "\t");
					System.out.print(element.getAttribute("type"));
					System.out.println();
				}
			}

		} catch (IOException e) {
			e.printStackTrace();
		} catch (DOMException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings("unused")
	private String getData(Element element, String tagName) {
		NodeList nodeListChild = element.getElementsByTagName(tagName);
		if (nodeListChild != null && nodeListChild.getLength() > 0) {
			Element childElement = (Element) nodeListChild.item(0);
			return childElement.getFirstChild().getNodeValue();
		}
		return null;
	}
}